From bippy-a5840b7849dd Mon Sep 17 00:00:00 2001
From: Greg Kroah-Hartman <gregkh@linuxfoundation.org>
To: <linux-cve-announce@vger.kernel.org>
Reply-to: <cve@kernel.org>, <linux-kernel@vger.kernel.org>
Subject: CVE-2024-36017: rtnetlink: Correct nested IFLA_VF_VLAN_LIST attribute validation

Description
===========

In the Linux kernel, the following vulnerability has been resolved:

rtnetlink: Correct nested IFLA_VF_VLAN_LIST attribute validation

Each attribute inside a nested IFLA_VF_VLAN_LIST is assumed to be a
struct ifla_vf_vlan_info so the size of such attribute needs to be at least
of sizeof(struct ifla_vf_vlan_info) which is 14 bytes.
The current size validation in do_setvfinfo is against NLA_HDRLEN (4 bytes)
which is less than sizeof(struct ifla_vf_vlan_info) so this validation
is not enough and a too small attribute might be cast to a
struct ifla_vf_vlan_info, this might result in an out of bands
read access when accessing the saved (casted) entry in ivvl.

The Linux kernel CVE team has assigned CVE-2024-36017 to this issue.


Affected and fixed versions
===========================

	Issue introduced in 4.9 with commit 79aab093a0b5 and fixed in 4.19.314 with commit 8ac69ff2d0d5
	Issue introduced in 4.9 with commit 79aab093a0b5 and fixed in 5.4.276 with commit 5e7ef2d88666
	Issue introduced in 4.9 with commit 79aab093a0b5 and fixed in 5.10.217 with commit 6c8f44b02500
	Issue introduced in 4.9 with commit 79aab093a0b5 and fixed in 5.15.159 with commit f3c1bf3054f9
	Issue introduced in 4.9 with commit 79aab093a0b5 and fixed in 6.1.91 with commit 6e4c7193954f
	Issue introduced in 4.9 with commit 79aab093a0b5 and fixed in 6.6.31 with commit 206003c748b8
	Issue introduced in 4.9 with commit 79aab093a0b5 and fixed in 6.8.10 with commit 4a4b9757789a
	Issue introduced in 4.9 with commit 79aab093a0b5 and fixed in 6.9 with commit 1aec77b2bb2e

Please see https://www.kernel.org for a full list of currently supported
kernel versions by the kernel community.

Unaffected versions might change over time as fixes are backported to
older supported kernel versions.  The official CVE entry at
	https://cve.org/CVERecord/?id=CVE-2024-36017
will be updated if fixes are backported, please check that for the most
up to date information about this issue.


Affected files
==============

The file(s) affected by this issue are:
	net/core/rtnetlink.c


Mitigation
==========

The Linux kernel CVE team recommends that you update to the latest
stable kernel version for this, and many other bugfixes.  Individual
changes are never tested alone, but rather are part of a larger kernel
release.  Cherry-picking individual commits is not recommended or
supported by the Linux kernel community at all.  If however, updating to
the latest release is impossible, the individual changes to resolve this
issue can be found at these commits:
	https://git.kernel.org/stable/c/8ac69ff2d0d5be9734c4402de932aa3dc8549c1a
	https://git.kernel.org/stable/c/5e7ef2d88666a0212db8c38e6703864b9ce70169
	https://git.kernel.org/stable/c/6c8f44b02500c7d14b5e6618fe4ef9a0da47b3de
	https://git.kernel.org/stable/c/f3c1bf3054f96ddeab0621d920445bada769b40e
	https://git.kernel.org/stable/c/6e4c7193954f4faab92f6e8d88bc5565317b44e7
	https://git.kernel.org/stable/c/206003c748b88890a910ef7142d18f77be57550b
	https://git.kernel.org/stable/c/4a4b9757789a1551d2df130df23bfb3545bfa7e8
	https://git.kernel.org/stable/c/1aec77b2bb2ed1db0f5efc61c4c1ca3813307489
